CSECT IOPT
      integer function iopt(narg,nopt,nsin,nstop)
c     returns an error code; 0 if no errors
c     and save things in files
      parameter (nguard=4,noptm=5)
c     nguard: cadenas a guardar; noptm: max. numero de opciones
c     narg exact number of needed arguments
c     nopt <= noptm; narg+nopt-nsin <= nguard 
c     nvalues number of options with values accepted
c     nopt possible options; the first nsin options dont need a value    
c     the first nstop options will make to stop option analysis and
c     return number of option
c     nopt-nsin last options need values which will be stored
c     nval values; the fist one without option; 
c     return 0       
      common /filens/ files(nguard) 
      character*100 files,argum,value
      common /opciones/ optgs(noptm)
      character*8 optgs,text,textg
      character*20 msg(5)
      data msg /'unknown option: ',': needs a value'
     *           ,' argument/s  missing','extra argument: '
     *           ,'bad option'/
      do 10, i= 1,3
10      files(i) = ''
      iarg=0
      marg=0
      iopt=0
      do 600,i=1,nguard+nsin+1
         text = ''
         value = ''
         iarg=iarg+1
         call getarg(iarg,argum)
c         print *,'comienzo iopt',i,argum
         if (argum .eq.'') then
             go to 700     
         end if
         largoa=lenoc(argum)
         if (argum(1:2).eq.'--') then
             if (largoa .gt.2) text=argum(3:)
         elseif (argum(1:1) .eq. '-') then
             if (largoa .gt. 1) text=argum(2:2)
             if (largoa .gt. 2) value=argum(3:)
         else
            marg=marg+1
c            print *,'no es opcion marg,argum',marg,argum   
            if (marg .le. narg) then
                 files(marg)=argum
            else 
                 print *,msg(4),argum(1:largoa)
                 iopt=104
                 return
            end if
            go to 600 
         end if
c         print *, 'iopt text value',i,iarg,text,value
         if (text.eq.'') then
            print *,msg(5),argum(1:largoa)
            return
         end if
c     ANALISIS DE OPCION       
        do 400 k=1,nopt
             textg=optgs(k)
             largo=lenoc(text)
             if (largo .gt. lenoc(textg)) go to 400
             do 300 j=1,largo
                 if(text(j:j) .ne. textg(j:j)) go to 400 
 300         continue
c     has found an option ...
c            print *,'i,iarg,option value',i,iarg,k,value
             if (k.le.nstop) then 
                 if (value .ne.'') go to 500
                 iopt=k
c     has found help or version ...
                 return
             end if
             if (k .le. nopt-nsin) then 
                 go to 600
             else if (k .gt. nopt-nsin) then
c                  print *, 'debo buscar un valor' 
               if (value .eq. '') then
                     iarg=iarg+1
                     call getarg(iarg,value)
c                     print *, 'medio getarg',i,iarg value
                     if (value.eq.'') then
                         print *,argum(1:largoa),msg(2)
                         iopt=102
                         return
                     end if
               end if
               files(k-nsin+narg)=value
c               print *,i,iarg,k,value
               go to 600
          end if 
 400    continue    
 500     print *,msg(1),argum(1:largoa) 
         iopt=101
         return
 600  continue
 700  continue
       if (marg.lt.narg) then
          print *,argum(1:largo), msg(3)
          iopt=103
          return
      else
          iopt=0
      end if
      return 
      end
