CSECT   POST
cloli NOUTP changed to NOUTTP; then INOUTP to NOUTP as in tapes2.inc 
cloli INTAPE, LIBTP do not appear 
cloli CKNAME added
cloli writing in isim (ires eliminated)
 
      SUBROUTINE POST (lpost)
 
C AUTHOR...: WRN
C DATE ....: 14-APR-1990
C REMARKS..: POST PROCESSOR FOR SCEPTRE OUTPUT FILE
 
      PARAMETER  (MAXOUT=100,MAXVEK=50000)
        include "tapes2.inc" 
cloli COMMON /TAPES/   NOUTP,INTAPE,LIBTP,INOUTP moved to tapes2.inc
      COMMON /CNTRLS/  CNTRL(160)
      DOUBLE PRECISION CNTRL,XRUNNO
         EQUIVALENCE  (CNTRL(32),XRUNNO)
 
      DOUBLE PRECISION HEADNG(9,11)
      CHARACTER*792    WTITEL
         EQUIVALENCE  (WTITEL,HEADNG(1,1))
      DOUBLE PRECISION OUTREQ(MAXOUT)
      DOUBLE PRECISION TEMP,XTYPE
      DIMENSION        RMIN(2*MAXOUT),RMAX(2*MAXOUT)
      REAL             BUFFER(3000)
      COMPLEX          CBUF(1500)
         EQUIVALENCE  (CBUF(1),BUFFER(1))
      REAL             VEKTOR(MAXVEK)
      CHARACTER*1      CK(MAXOUT)
      character*4      CKNAME(MAXOUT,2)
      CHARACTER*10     WTEMP
      CHARACTER*8      WNAME
      LOGICAL          LAC,LMASTR,LFIRST,LERROR,lpost
 
      DATA             LAC /.FALSE./
 
      WRITE (NOUTTP,600)
  600 FORMAT ('0S C E P T R E   post processing',/)
 
      lpost=.false.
      REWIND (NOUTP)
      LFIRST=.TRUE.
      NRUNNO=NINT(XRUNNO)-1
      LMASTR=NRUNNO.EQ.0
 
      READ (NOUTP) XTYPE
      IF (NINT(XTYPE).EQ.1) LAC=.TRUE.
 
C HEADINGS:
 
      READ (NOUTP) TEMP
      LENHDG=NINT(TEMP)
      IF (LENHDG.GT.0) THEN
         DO 10 N=1,LENHDG
            READ (NOUTP) (HEADNG(M,N),M=1,9)
            WRITE(NOUTTP,601)  (HEADNG(M,N),M=1,9)
   10    CONTINUE
      END IF
  601 FORMAT (1X,9A8)
 
C NO. OF OUTPUT REQUESTS:
 
      READ (NOUTP) TEMP
      LNINDX=NINT(TEMP)
      LMAX=LNINDX
      IF (LAC) LMAX=2*LNINDX
      DO 20 N=1,LNINDX
         READ (NOUTP) OUTREQ(N)
   20 CONTINUE
 
C AC FORMAT:
 
cloli IF (LAC) READ (NOUTP) (CK(I),I=1,LNINDX)
      IF (LAC) then 
         READ (noutp) (CK(I),I=1,LNINDX)
         ckname(1,1)= ''
         CKNAME(1,2)= ''
         do 25 i=2,LNINDX
            if (ck(I).eq.'C') then 
               ckname(I,1)='REAL'
               ckname(I,2)='IMAG'
           elseif (ck(I).EQ.'R') then
               ckname(I,1)='MAG'
               ckname(I,2)='RAD'
            elseif (ck(I).eq.'D') then
               ckname(I,1)='MAG'
                ckname(I,2)='DEG' 
            end if 
 25      CONTINUE

      end if
 
C FILL OUTPUT BUFFER:
 
      KOUNT=0
 
   30 READ (NOUTP) NGRPS
      IF (NGRPS.EQ.0) GO TO  99
      KOUNT=KOUNT+NGRPS
      LEND=NGRPS*LNINDX
      IF (LAC) THEN
         READ (NOUTP) (CBUF(K),K=1,LEND)
       ELSE
         READ (NOUTP) (BUFFER(K),K=1,LEND)
      END IF
 
C SET FIRST VALUE FOR MINIMUM AND MAXIMUM:
 
      IF (LFIRST) THEN
         LFIRST=.FALSE.
         DO 35 J=1,LMAX
            RMIN(J)=BUFFER(J)
            RMAX(J)=BUFFER(J)
   35    CONTINUE
      END IF
 
C MIN, MAX:
 
      DO 40 I=1,NGRPS
      DO 40 J=1,LMAX
         RMIN(J)=MIN(RMIN(J),BUFFER((I-1)*LMAX+J))
         RMAX(J)=MAX(RMAX(J),BUFFER((I-1)*LMAX+J))
   40 CONTINUE
      GO TO 30
 
C OUTPUT STATISTIC:
 
   99 CONTINUE
      WRITE (NOUTTP,603)
  603 FORMAT ('0no. variable   type            minimum     maximum',/)
 
      IF (LAC) THEN
         DO 80 J=1,LMAX,2
            K=(J-1)/2+1
            WTEMP=' '
            IF (CK(K).EQ.'C') WTEMP='REAL'
            IF (CK(K).EQ.'D') WTEMP='MAG'
            IF (CK(K).EQ.'R') WTEMP='MAG'
            WRITE (NOUTTP,604) J,OUTREQ(K),WTEMP,RMIN(J),RMAX(J)
            IF (CK(K).EQ.'C') WTEMP='IMAG'
            IF (CK(K).EQ.'D') WTEMP='DEG'
            IF (CK(K).EQ.'R') WTEMP='RAD'
            WRITE (NOUTTP,604) J+1,OUTREQ(K),WTEMP,RMIN(J+1),RMAX(J+1)
   80    CONTINUE
  166    format(A,1P,100E13.5)
  167    format(A,4X,A6,99A13)
         write(isim,166)'#min',(RMIN(J),RMIN(J+1),J=1,LMAX,2)
         write(isim,166)'#max',(RMAX(J),RMAX(J+1),J=1,LMAX,2)
         write(isim,167)'#tip', ((CKNAME(I,L),L=1,2),I=1,LNINDX)
       ELSE
         WTEMP='REAL'
         DO 70 J=1,LMAX
            WRITE (NOUTTP,604) J,OUTREQ(J),WTEMP,RMIN(J),RMAX(J)
   70    CONTINUE
         write(isim,166)'#min',(RMIN(J),J=1,LMAX)
         write(isim,166)'#max',(RMAX(J),J=1,LMAX)
      END IF
  604 FORMAT (1X,I3,2X,A8,2X,A,2X,1P,2E12.4)
 
      WRITE (NOUTTP,608) KOUNT
  608 FORMAT ('0no. of solution points :',I8)
  60  format(A,I7)
      write(isim,60 )'#no. of solution points: ',KOUNT
 
C INITIALIZE DA FILE:
 
      IF (LMASTR) THEN
         CALL POS000 ('INITIAL',LERROR)
         IF (LERROR) GO TO 9999
      END IF
 
C STORE HEADER LINES:
 
      IF (LMASTR) THEN
         IF (LENHDG.GT.0) THEN
            CALL POSWC1 ('HEADING',WTITEL,LENHDG*72,LERROR)
            IF (LERROR) GO TO 9999
         END IF
      END IF
 
C  STORE EACH VARIABLE:
 
      DO 100 J=1,LMAX
         IF (LAC.AND.J.EQ.2) GO TO 100
         REWIND (NOUTP)
         READ (NOUTP) XTYPE
         READ (NOUTP) TEMP
         LENHDG=NINT(TEMP)
         IF (LENHDG.GT.0) THEN
            DO 110 N=1,LENHDG
               READ (NOUTP) (HEADNG(M,N),M=1,9)
  110       CONTINUE
         END IF
         READ (NOUTP) TEMP
         LNINDX=NINT(TEMP)
         LMAX=LNINDX
         IF (LAC) LMAX=2*LNINDX
         DO 120 N=1,LNINDX
            READ (NOUTP) OUTREQ(N)
  120    CONTINUE
         IF (LAC) READ (NOUTP) (CK(I),I=1,LNINDX)
 
         KVEKT=0
  130    READ (NOUTP) NGRPS
         IF (NGRPS.EQ.0) GO TO 199
         LEND=NGRPS*LNINDX
         IF (LAC) THEN
            READ (NOUTP) (CBUF(K),K=1,LEND)
          ELSE
            READ (NOUTP) (BUFFER(K),K=1,LEND)
         END IF
         DO 140 I=1,NGRPS
            INDVEK=KVEKT+I
            IF ((INDVEK+2).LE.MAXVEK) THEN
               VEKTOR(INDVEK)=BUFFER((I-1)*LMAX+J)
             ELSE
               INDVEK=INDVEK-1
               WRITE (NOUTTP,
     *               '(''0POST: internal vektor overflow, only '',
     *               I6,'' points are stored'')') INDVEK
               GO TO 199
            END IF
  140    CONTINUE
         KVEKT=KVEKT+NGRPS
         GO TO 130
  199    CONTINUE
         VEKTOR(INDVEK+1)=RMIN(J)
         VEKTOR(INDVEK+2)=RMAX(J)
         INDVEK=INDVEK+2
         IF (LAC) THEN
            K=(J-1)/2+1
            IF (MOD(J,2).EQ.1) THEN
               WTEMP='A'
             ELSE
               WTEMP=' '
               IF (CK(K).EQ.'C') WTEMP='I'
               IF (CK(K).EQ.'D') WTEMP='D'
               IF (CK(K).EQ.'R') WTEMP='R'
            ENDIF
            WRITE (WNAME,'(A6,A1,I1)') OUTREQ(K),WTEMP(1:1),NRUNNO
          ELSE
            WRITE (WNAME,'(A6,''_'',I1)') OUTREQ(J),NRUNNO
         END IF
         CALL POSWR4 (WNAME,VEKTOR,INDVEK,LERROR)
         IF (LERROR) GO TO 9999
  100 CONTINUE
 
      WRITE (NOUTTP,609)
  609 FORMAT ('0end of post processing')
 
      REWIND (NOUTP)
      lpost=.true.
 9999 RETURN
 
      END
